Attribute VB_Name = "Module1"
Rem LaunchB
Private Declare Function FindExecutable Lib "shell32.dll" Alias _
   "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As _
   String, ByVal lpResult As String) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias _
   "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As _
   String, ByVal lpFile As String, ByVal lpParameters As String, _
   ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long



Rem ISCONNECTED:
Public Declare Function RasEnumConnections Lib "RasApi32.dll" Alias "RasEnumConnectionsA" (lpRasCon As Any, lpcb As Long, lpcConnections As Long) As Long
Public Declare Function RasGetConnectStatus Lib "RasApi32.dll" Alias "RasGetConnectStatusA" (ByVal hRasCon As Long, lpStatus As Any) As Long
Public Const RAS95_MaxEntryName = 256
Public Const RAS95_MaxDeviceType = 16
Public Const RAS95_MaxDeviceName = 32
Public Type RASCONN95
    dwSize As Long
    hRasCon As Long
    szEntryName(RAS95_MaxEntryName) As Byte
    szDeviceType(RAS95_MaxDeviceType) As Byte
    szDeviceName(RAS95_MaxDeviceName) As Byte
End Type
Public Type RASCONNSTATUS95
    dwSize As Long
    RasConnState As Long
    dwError As Long
    szDeviceType(RAS95_MaxDeviceType) As Byte
    szDeviceName(RAS95_MaxDeviceName) As Byte
End Type
Rem -
Public Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, ByVal sProxyBypass As String, ByVal lFlags As Long) As Long
Public Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" (ByVal hInternetSession As Long, ByVal surl As String, ByVal sHeaders As String, ByVal lHeadersLength As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long
Public Declare Function InternetReadFile Lib "wininet.dll" (ByVal hFile As Long, ByVal sBuffer As String, ByVal lNumBytesToRead As Long, lNumberOfBytesRead As Long) As Integer
Public Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInet As Long) As Integer
Public Const IF_FROM_CACHE = &H1000000
Public Const IF_MAKE_PERSISTENT = &H2000000
Public Const IF_NO_CACHE_WRITE = &H4000000
Private Const BUFFER_LEN1 = 256
Private Const BUFFER_LEN = 128

Option Explicit
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetActiveWindow Lib "user32" (ByVal hwnd As Long) As Long


Rem TRAYICON


Public Const WM_RBUTTONUP = &H205

Global Const WM_MOUSEMOVE = &H200
Global Const NIM_ADD = 0&
Global Const NIM_DELETE = 2&
Global Const NIM_MODIFY = 1&
Global Const NIF_TIP = &H4
Global Const NIF_ICON = 2&
Global Const NIF_MESSAGE = 1&
Global Const ABM_GETTASKBARPOS = &H5&

Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Type NOTIFYICONDATA
        cbSize As Long
        hwnd As Long
        uID As Long
        uFlags As Long
        uCallbackMessage As Long
        hIcon As Long
        szTip As String * 64
End Type

Type APPBARDATA
        cbSize As Long
        hwnd As Long
        uCallbackMessage As Long
        uEdge As Long
        rc As RECT
        lParam As Long
End Type

Global Notify As NOTIFYICONDATA
Global BarData As APPBARDATA

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
Private Declare Function SHAppBarMessage Lib "shell32.dll" (ByVal dwMessage As Long, pData As APPBARDATA) As Long



Public Function IsConnected() As Boolean
Dim s As String
If InStr(App.CompanyName, "localhost") > 0 Then IsConnected = True: Exit Function

s$ = GetSetting("WebNews", "Options", "net")
If s = "online" Then
      IsConnected = True: Exit Function
ElseIf s = "offline" Then
      IsConnected = False: Exit Function
End If


Dim TRasCon(255) As RASCONN95
Dim lg As Long
Dim lpcon As Long
Dim RetVal As Long
Dim Tstatus As RASCONNSTATUS95

TRasCon(0).dwSize = 412
lg = 256 * TRasCon(0).dwSize

RetVal = RasEnumConnections(TRasCon(0), lg, lpcon)
If RetVal <> 0 Then
     frmMain.msg "Chyba pri zisovan pripojenia k internetu."
     Exit Function
End If

Tstatus.dwSize = 160
RetVal = RasGetConnectStatus(TRasCon(0).hRasCon, Tstatus)
If Tstatus.RasConnState = &H2000 Then
    IsConnected = True
Else
    IsConnected = False
End If

End Function


Sub modIcon(Form1 As Form, IconID As Long, Icon As Object, ToolTip As String)
    Dim Result As Long
    Notify.cbSize = 88&
    Notify.hwnd = Form1.hwnd
    Notify.uID = IconID
    Notify.uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
    Notify.uCallbackMessage = WM_MOUSEMOVE
    Notify.hIcon = Icon
    Notify.szTip = ToolTip & Chr$(0)
    Result = Shell_NotifyIcon(NIM_MODIFY, Notify)
End Sub

Sub AddIcon(Form1 As Form, IconID As Long, Icon As Object, ToolTip As String)
    Dim Result As Long
    BarData.cbSize = 36&
    Result = SHAppBarMessage(ABM_GETTASKBARPOS, BarData)
    Notify.cbSize = 88&
    Notify.hwnd = Form1.hwnd
    Notify.uID = IconID
    Notify.uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
    Notify.uCallbackMessage = WM_MOUSEMOVE
    Notify.hIcon = Icon
    Notify.szTip = ToolTip & Chr$(0)
    Result = Shell_NotifyIcon(NIM_ADD, Notify)
End Sub

Sub delIcon(IconID As Long)
    Dim Result As Long
    Notify.uID = IconID
    Result = Shell_NotifyIcon(NIM_DELETE, Notify)
End Sub


Public Function GetUrlSource(ssURL As String) As String
If InStr(ssURL, "idnes") > 0 Then GetUrlSource = OtvorTxt("idnes.txt"): Exit Function

Dim sBuffer As String * BUFFER_LEN, iResult As Integer, sData As String
Dim hInternet As Long, hSession As Long, lReturn As Long, surl$, perc As Integer
hSession = InternetOpen("wininet", 1, vbNullString, vbNullString, 0)
surl = ssURL
If Not Left(LCase(surl), 7) = "http://" Then surl = "http://" & surl
If hSession Then hInternet = InternetOpenUrl(hSession, surl, vbNullString, 0, IF_NO_CACHE_WRITE, 0)
If hInternet Then
    iResult = InternetReadFile(hInternet, sBuffer, BUFFER_LEN, lReturn)
    sData = sBuffer
    Do While lReturn <> 0
        iResult = InternetReadFile(hInternet, sBuffer, BUFFER_LEN, lReturn)
        sData = sData + Mid(sBuffer, 1, lReturn)
        'frmMain.Refresh
        frmMain.Cakaj 50
        frmMain.SetStatus1 Int(Len(sData) / 1024) & " kb", 3
    Loop
End If
DoEvents
iResult = InternetCloseHandle(hInternet)
GetUrlSource = sData
End Function


Sub LaunchB(file$)
Dim FileName, Dummy As String, FileNumber As Integer, RetVal As Long
Dim BrowserExec As String * 255, BrowserExe$

BrowserExe = GetSetting("WebNews", "Options", "Browser")
If BrowserExe = "" Then
    If RetVal = 0 Then
        BrowserExec = Space(255)
        FileName = App.Path & "\temphtm.HTM"
        FileNumber = FreeFile
        Open FileName For Output As #FileNumber
        Write #FileNumber, "<HTML> <\HTML>"
        Close #FileNumber
        RetVal = FindExecutable(FileName, Dummy, BrowserExec)
        Kill FileName
        BrowserExe = Trim(BrowserExec)
    End If
    If RetVal <= 32 Or IsEmpty(BrowserExec) Then
        'Call ShellExecute(frmMain.hwnd, "Open", DocEvents.activeElement.toString, "", "", 1)
        MsgBox "Web strnka nebola otvoren, browser nastavte v menu Nastavenie\Vlastnosti programu", vbExclamation, "Chyba"
    Else
        RetVal = ShellExecute(frmMain.hwnd, "open", BrowserExe, file, Dummy, 1)
        If RetVal <= 32 Then
              MsgBox "Web strnka nebola otvoren, browser nastavte v menu Nastavenie\Vlastnosti programu", vbExclamation, "Chyba"
        Else: SaveSetting "WebNews", "Options", "Browser", BrowserExe
        End If
    End If
Else
        RetVal = Shell(BrowserExe & " " & file, vbNormalNoFocus)
End If
End Sub
